package itheima.com;

import java.util.ArrayList;
import java.util.Collections;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;

/**
 * 5.我们要给每个字母配一个1-26之间的整数，具体怎么分配由你决定，但不同字母的完美度不同，
 * 而一个字符串的完美度等于它里面所有字母的完美度之和，且不在乎字母大小写，也就是说字母F和f的完美度是一样的。
 * 现在给定一个字符串，输出它的最大可能的完美度。 例如：dad，你可以将26分配给d，25分配给a，这样整个字符串最大可能的完美度为77。
 * 
 * @author Burning
 * 
 */
public class Exercise5 {

	// 一个字符的最大完美度
	private final static int MAX_VALUE = 26;

	public static void main(String[] args) {

		// 定义一个字符串，并忽略大小写
		String str = "dDa".toUpperCase();

		// 将字符串中的字符和出现次数分别作为key和value存储到hashMap中，并得到这个map
		Map<Character, Integer> map = buildHashMap(str);

		// 将map中的所有value值存到list集合中，集合中元素按照升序排序
		List<Integer> list = buildList(map);

		// 根据list集合打印该字符串的最大完美度
		getResult(list);
	}

	/**
	 * 将字符串中的字符和出现次数分别作为key和value存储到hashMap中
	 * 
	 * @param str
	 * @return
	 */
	private static Map<Character, Integer> buildHashMap(String str) {

		Map<Character, Integer> map = new HashMap<Character, Integer>();

		for (int i = 0; i < str.length(); i++) {

			char currentCharacter = str.charAt(i);
			// 如果map中不包含该字符
			if (!map.containsKey(currentCharacter)) {
				map.put(currentCharacter, 1);
				// 如果map中包含该字符,出现次数加1
			} else {
				map.put(currentCharacter, map.get(currentCharacter) + 1);
			}
		}
		return map;
	}

	/**
	 * 将map中的所有value值存到list集合中，集合中元素按照升序排序
	 * 
	 * @param map
	 * @return
	 */
	private static List<Integer> buildList(Map<Character, Integer> map) {

		List<Integer> list = new ArrayList<Integer>();
		//遍历map，将其中所有value传入list集合
		for (Entry<Character, Integer> entry : map.entrySet()) {
			list.add(entry.getValue());
		}
		// 对集合排序
		Collections.sort(list);
		return list;
	}

	/**
	 * 根据list集合打印该字符串的最大完美度
	 * 
	 * @param list
	 */
	private static void getResult(List<Integer> list) {
		int value = MAX_VALUE;
		int result = 0;
		// 遍历list集合计算最大完美度
		for (int i = list.size() - 1; i >= 0; i--, value--) {
			result += list.get(i) * value;
		}
		System.out.println(result);
	}

}
